﻿Scriptname JaxonzEnhGrabMCM extends SKI_ConfigBase  
{configuration menu}

import Debug
import Utility

GlobalVariable Property giOneTimeWarned Auto

Bool Property bLockDownCell Auto ;reset to false on game load by player alias

JaxonzEnhGrab Property scrEnhGrab Auto
JaxonzEnhGrab scrQuest
int function GetVersion()
    return 13
    OnConfigInit()
endFunction

event OnConfigInit()
    Pages = new string[4]
    Pages[0] = "Settings"
    Pages[1] = "Keyboard Layout"
    Pages[2] = "Axes Layout"
    Pages[3] = "Advanced Operations"
    
    scrQuest = scrEnhGrab
endEvent

;REQUIRED FOR MCM MENU CONTROL BY JAXONZ UTILITIES
;event OnConfigManagerReady(string a_eventName, string a_strArg, float a_numArg, Form a_sender)
;Trace(GetName() + "::OnConfigManagerReady, IsActive():" + IsActive() + ", ((Self as Quest) as JaxonzEnhGrab).IsActive():" + ((Self as Quest) as JaxonzEnhGrab).IsActive())
;	if IsActive()
;Trace(GetName() + "::OnConfigManagerReady, calling on parent")
;		Parent.OnConfigManagerReady(a_eventName, a_strArg, a_numArg, a_sender)
;	EndIf
;endEvent
;END REQUIRED FOR MCM MENU CONTROL BY JAXONZ UTILITIES

event OnVersionUpdate(int a_version)
	OnConfigInit()
endEvent

Event OnPageReset(string page)
	SetCursorFillMode(TOP_TO_BOTTOM)
	UnloadCustomContent()

	If (page == "") ; show title page / help info
		AddTextOption("Positioner is what Grab Object should have been.","")
		AddTextOption("It allows precise positioning of objects and","")
		AddTextOption("the ability to lock objects in place so that","")
		AddTextOption("they are not knocked over.","")
		AddEmptyOption()
		AddTextOption("Select an object with keypad Enter,","")
		AddTextOption("then use the numpad and arrow keys to","")
		AddTextOption("precisely position the object.","")
		AddTextOption("Tap Numpad Enter or Numpad . when done.","")
		AddTextOption("$See the Settings tab for key explanations.","")
		AddEmptyOption()
		AddTextOption("Hope you enjoy it.","")
		SetCursorPosition(1)
		AddHeaderOption("Help Topics")		
		AddTextOptionST("optSelectingObjects","Selecting Objects","")
		AddTextOptionST("optBasics","The Basics","")
		AddTextOptionST("optLockInPlace","Lock an Item in Place","")
		AddTextOptionST("optSetTable","Set a Table","")
		AddTextOptionST("optMount","Mount Shields or Weapons","")
		AddTextOptionST("optMoveFurniture","Move Furniture","")
		AddTextOptionST("optLockDownEverything","Lock Down Everything in a Cell","")
		AddTextOptionST("optTakeStaticsWithYou","Take Statics With You","")
		AddTextOptionST("optManipulateLights","Manipulate Lights","")
		AddTextOptionST("optCaveats","Caveats","")
		AddTextOptionST("optSkyrimBugs","SkyRim Bugs","")
		
	ElseIf (page == "Settings")
		AddHeaderOption("Main")
		AddKeyMapOptionST("optHotKey", "Select Object/Lock Object", scrEnhGrab.giHotkey.GetValueInt(), OPTION_FLAG_WITH_UNMAP)
		AddKeyMapOptionST("optDrop", "Drop and release object", scrEnhGrab.kDrop.GetValueInt(), OPTION_FLAG_NONE)
		AddKeyMapOptionST("optCollectStatic", "Take object", scrEnhGrab.kCollectStatic.GetValueInt(), OPTION_FLAG_NONE)
		AddKeyMapOptionST("optCopy", "Copy Object", scrEnhGrab.kCopy.GetValueInt(), OPTION_FLAG_NONE)
		AddKeyMapOptionST("optUndo", "Undo", scrEnhGrab.kUndo.GetValueInt(), OPTION_FLAG_NONE)
		AddKeyMapOptionST("optReset", "Reset", scrEnhGrab.kReset.GetValueInt(), OPTION_FLAG_NONE)
		AddKeyMapOptionST("optDelete", "Delete", scrEnhGrab.kDelete.GetValueInt(), OPTION_FLAG_NONE)
		AddHeaderOption("Object Scaling")
		AddKeyMapOptionST("optScaleLarger", "Scale Object Larger", scrEnhGrab.kScaleLarger.GetValueInt(), OPTION_FLAG_NONE)
		AddKeyMapOptionST("optScaleSmaller", "Scale Object Smaller", scrEnhGrab.kScaleSmaller.GetValueInt(), OPTION_FLAG_NONE)
		SetCursorPosition(1)
		AddHeaderOption("Object Movement")
		AddKeyMapOptionST("optUp", "Move object up", scrEnhGrab.kUp.GetValueInt(), OPTION_FLAG_NONE)
		AddKeyMapOptionST("optDown", "Move object down", scrEnhGrab.kDown.GetValueInt(), OPTION_FLAG_NONE)
		AddKeyMapOptionST("optFwd", "Move object forward", scrEnhGrab.kFwd.GetValueInt(), OPTION_FLAG_NONE)
		AddKeyMapOptionST("optBack", "Move object backward", scrEnhGrab.kBack.GetValueInt(), OPTION_FLAG_NONE)
		AddKeyMapOptionST("optleft", "Move object left", scrEnhGrab.kLeft.GetValueInt(), OPTION_FLAG_NONE)
		AddKeyMapOptionST("optRight", "Move object right", scrEnhGrab.kRight.GetValueInt(), OPTION_FLAG_NONE)
		AddKeyMapOptionST("optMovetoTarget", "$kMovetoTarget", scrEnhGrab.kMovetoTarget.GetValueInt(), OPTION_FLAG_NONE)
		AddHeaderOption("Object Rotation")
		AddKeyMapOptionST("optLevel", "Level object", scrEnhGrab.kLevel.GetValueInt(), OPTION_FLAG_NONE)
		AddKeyMapOptionST("optPitchUp", "Rotate object pitch up", scrEnhGrab.kPitchUp.GetValueInt(), OPTION_FLAG_NONE)
		AddKeyMapOptionST("optPitchDown", "Rotate object pitch down", scrEnhGrab.kPitchDown.GetValueInt(), OPTION_FLAG_NONE)
		AddKeyMapOptionST("optYawLeft", "Rotate object yaw left", scrEnhGrab.kYawLeft.GetValueInt(), OPTION_FLAG_NONE)
		AddKeyMapOptionST("optYawRight", "Rotate object yaw right", scrEnhGrab.kYawRight.GetValueInt(), OPTION_FLAG_NONE)
		AddKeyMapOptionST("optRollLeft", "Rotate object roll left", scrEnhGrab.kRollLeft.GetValueInt(), OPTION_FLAG_NONE)
		AddKeyMapOptionST("optRollRight", "Rotate object roll right", scrEnhGrab.kRollRight.GetValueInt(), OPTION_FLAG_NONE)
	ElseIf Page == "Keyboard Layout"
		LoadCustomContent("JaxonzEnhGrab/Keyboard_ENGLISH.dds")
	ElseIf Page == "Axes Layout"
		LoadCustomContent("JaxonzEnhGrab/Axes_ENGLISH.dds")
	ElseIf Page == "Advanced Operations"
		AddHeaderOption("In Current Cell")
		AddTextOptionST("optLockDownCell", "Lock Everything In Place","Do It")
		AddHeaderOption("Global Settings")
		AddSliderOptionST("optMovementAmount", "Maximum move distance", scrEnhGrab.gfMovementAmount.GetValue())
		AddSliderOptionST("optMovementSpeed", "Movement speed", scrEnhGrab.gfMovementSpeed.GetValue())
		AddSliderOptionST("optRotationAmount", "Maximum rotation degrees", scrEnhGrab.gfRotationAmount.GetValue())
		AddSliderOptionST("optRotationSpeed", "Rotation speed", scrEnhGrab.gfRotationSpeed.GetValue())
		AddSliderOptionST("optTokenWeight", "Collected Object Weight", scrEnhGrab.giTokenWeight.GetValueInt())
		AddToggleOptionST("optLightsSelectable", "Make Lights Visible and Selectable", bLightsSelectable)
		AddToggleOptionST("optResetKeyMappings", "Reset Default Key Mappings", false)
		AddHeaderOption("Diagnostics")
		AddTextOptionST("optCheckSKSEPlugin", "Check SKSE plugin installation","Validate")
	EndIf	
EndEvent

Event OnConfigClose()
	
	scrEnhGrab.OnSettingsChanged()
	
	if bLightsSelectableChanged
		Wait(0.1)
		string sGrabbableLightModelPath = "JaxonzEnhGrabLightMarker.nif"
		int kLight = 31
		Cell celCurrent = Game.GetPlayer().GetParentCell()
		ObjectReference objLight
		Form frmLight
		Int iIndex = celCurrent.GetNumRefs(kLight)
		if bLightsSelectable
			Notification("Making light sources visible")
		Else
			Notification("Making light sources invisible")
		EndIf
		while iIndex
		    iIndex -= 1
		    objLight = celCurrent.GetNthRef(iIndex, kLight)
		    frmLight = objLight.GetBaseObject()
		    
		    If (frmLight.GetWorldModelPath() == "") || (frmLight.GetWorldModelPath() == sGrabbableLightModelPath)
		    	objLight.Disable()
				If bLightsSelectable
					frmLight.SetWorldModelPath(sGrabbableLightModelPath)
				Else
					frmLight.SetWorldModelPath("")				
				EndIf
		    	objLight.Enable()
		    EndIf
		endwhile
	EndIf
EndEvent

Bool bLightsSelectable
bool bLightsSelectableChanged
state optLightsSelectable
	event OnSelectST()
		bLightsSelectableChanged = true
		bLightsSelectable = !bLightsSelectable
		SetToggleOptionValueST(bLightsSelectable)
	endEvent

	event OnHighlightST()
		 SetInfoText("Click here to make light sources in the current cell visible so that they can be selected and positioned.\nIf this option is left selected, it will revert in the next game session.")
	endEvent

endState

state optTokenWeight
	event OnSliderOpenST()
        SetSliderDialogStartValue(scrEnhGrab.giTokenWeight.GetValueInt())
        SetSliderDialogDefaultValue(20)
        SetSliderDialogRange(0.0, 100.0)
        SetSliderDialogInterval(5.0)
	endEvent
	
	event OnSliderAcceptST(float value)
        scrEnhGrab.giTokenWeight.SetValue(value)
        SetSliderOptionValueST(value)
	endEvent
	
	event OnDefaultST()
		scrEnhGrab.giTokenWeight.SetValue(20)
		SetSliderOptionValueST(20)
	endEvent
	
	event OnHighlightST()
		 SetInfoText("Sets the weight of all static items collected to inventory.")
	endEvent	
endState

Bool Function WarnKeyConflict(String ConflictControl, String ConflictName)
;a helper function for hotkey assignment check
;shows OK/cancel dialog to user; returns True:OK or False:Cancel
	return ShowMessage("This key is already mapped to:\n" + conflictControl + "\n(" + conflictName + ")\nAre you sure you want to continue?", true, "Yes", "No")
EndFunction

state optHotKey
	event OnKeyMapChangeST(int keyCode, string conflictControl, string conflictName)
	    if (conflictControl == "") || WarnKeyConflict(ConflictControl, ConflictName)
	        scrEnhGrab.giHotKey.SetValueInt(keyCode)
	        SetKeyMapOptionValueST(keyCode)
	    endIf	    
	endEvent
	
	event OnHighlightST()
		 SetInfoText("Assign a key to select/release object to move.\nFirst grab an item by holding down the action key (typcially E), then press this key to start positioning.\nWhen finished positioning, press this key to lock the item in place. Locked items will not be disturbed by game action.")
	endEvent
endState

float fMovementAmountDefault = 100.0
state optMovementAmount
	event OnSliderOpenST()
        SetSliderDialogStartValue(scrEnhGrab.gfMovementAmount.GetValue())
        SetSliderDialogDefaultValue(fMovementAmountDefault)
        SetSliderDialogRange(10.0, 1000.0)
        SetSliderDialogInterval(25.0)
	endEvent
	
	event OnSliderAcceptST(float value)
        scrEnhGrab.gfMovementAmount.SetValue(value)
        SetSliderOptionValueST(value)
	endEvent
	
	event OnDefaultST()
		scrEnhGrab.gfMovementAmount.SetValue(fMovementAmountDefault)
		SetSliderOptionValueST(fMovementAmountDefault)
	endEvent
	
	event OnHighlightST()
		 SetInfoText("Sets the maximum number of units an object will move if keys are held down.\nThis allows for precise positioning.")
	endEvent	
endState

float fMovementSpeedDefault = 20.0
state optMovementSpeed
	event OnSliderOpenST()
        SetSliderDialogStartValue(scrEnhGrab.gfMovementSpeed.GetValue())
        SetSliderDialogDefaultValue(fMovementSpeedDefault)
        SetSliderDialogRange(5.0, 200.0)
        SetSliderDialogInterval(5.0)
	endEvent
	
	event OnSliderAcceptST(float value)
        scrEnhGrab.gfMovementSpeed.SetValue(value)
        SetSliderOptionValueST(value)
	endEvent
	
	event OnDefaultST()
		scrEnhGrab.gfMovementSpeed.SetValue(fMovementSpeedDefault)
		SetSliderOptionValueST(fMovementSpeedDefault)
	endEvent
	
	event OnHighlightST()
		 SetInfoText("Sets the speed that an object will move if keys are held down.")
	endEvent	
endState

float fRotationAmountDefault = 90.0
state optRotationAmount
	event OnSliderOpenST()
        SetSliderDialogStartValue(scrEnhGrab.gfRotationAmount.GetValue())
        SetSliderDialogDefaultValue(fRotationAmountDefault)
        SetSliderDialogRange(15.0, 180.0)
        SetSliderDialogInterval(15.0)
	endEvent
	
	event OnSliderAcceptST(float value)
        scrEnhGrab.gfRotationAmount.SetValue(value)
        SetSliderOptionValueST(value)
	endEvent
	
	event OnDefaultST()
		scrEnhGrab.gfRotationAmount.SetValue(fRotationAmountDefault)
		SetSliderOptionValueST(fRotationAmountDefault)
	endEvent
	
	event OnHighlightST()
		 SetInfoText("Sets the maximum number of degrees an object will rotate if keys are held down.\nThis allows for precise angular positioning. The default allows for perfect right angles. Set to 45 to help position crossed swords.")
	endEvent	
endState

float fRotationSpeedDefault = 30.0
state optRotationSpeed
	event OnSliderOpenST()
        SetSliderDialogStartValue(scrEnhGrab.gfRotationSpeed.GetValue())
        SetSliderDialogDefaultValue(fRotationSpeedDefault)
        SetSliderDialogRange(5.0, 100.0)
        SetSliderDialogInterval(5.0)
	endEvent
	
	event OnSliderAcceptST(float value)
        scrEnhGrab.gfRotationSpeed.SetValue(value)
        SetSliderOptionValueST(value)
	endEvent
	
	event OnDefaultST()
		scrEnhGrab.gfRotationSpeed.SetValue(fRotationSpeedDefault)
		SetSliderOptionValueST(fRotationSpeedDefault)
	endEvent
	
	event OnHighlightST()
		 SetInfoText("Sets the speed that an object will rotate if keys are held down.")
	endEvent	
endState

state optMoveToTarget
	event OnKeyMapChangeST(int keyCode, string conflictControl, string conflictName)
	    if (conflictControl == "") || WarnKeyConflict(ConflictControl, ConflictName)
	        scrEnhGrab.kMoveToTarget.SetValueInt(keyCode)
	        SetKeyMapOptionValueST(keyCode)
	    endIf	    
	endEvent

	event OnHighlightST()
		 SetInfoText("This key moves the object to the location under the cursor.")
	endEvent
endState

state optDrop
	event OnKeyMapChangeST(int keyCode, string conflictControl, string conflictName)
	    if (conflictControl == "") || WarnKeyConflict(ConflictControl, ConflictName)
	        scrEnhGrab.kDrop.SetValueInt(keyCode)
	        SetKeyMapOptionValueST(keyCode)
	    endIf	    
	endEvent

	event OnHighlightST()
		 SetInfoText("This key drops the object from its current position.\nDropped objects are moveable, so they may be knocked about by game action.")
	endEvent
endState

state optCollectStatic
	event OnKeyMapChangeST(int keyCode, string conflictControl, string conflictName)
	    if (conflictControl == "") || WarnKeyConflict(ConflictControl, ConflictName)
	        scrEnhGrab.kCollectStatic.SetValueInt(keyCode)
	        SetKeyMapOptionValueST(keyCode)
	    endIf	    
	endEvent

	event OnHighlightST()
		 SetInfoText("Pressing this key will move the current selected object to inventory. If the object cannot normally be grabbed, a token inventory item will be created. Dropping the token will place the object in the new location.")
	endEvent
endState

state optCopy
	event OnKeyMapChangeST(int keyCode, string conflictControl, string conflictName)
	    if (conflictControl == "") || WarnKeyConflict(ConflictControl, ConflictName)
	        scrEnhGrab.kCopy.SetValueInt(keyCode)
	        SetKeyMapOptionValueST(keyCode)
	    endIf	    
	endEvent

	event OnHighlightST()
		 SetInfoText("This key causes a duplicate object to be created at exactly the same location. Only simple objects can be copied, not complex things such as mannequins and weapon racks.")
	endEvent
endState

state optUndo
	event OnKeyMapChangeST(int keyCode, string conflictControl, string conflictName)
	    if (conflictControl == "") || WarnKeyConflict(ConflictControl, ConflictName)
	        scrEnhGrab.kUndo.SetValueInt(keyCode)
	        SetKeyMapOptionValueST(keyCode)
	    endIf	    
	endEvent

	event OnHighlightST()
		 SetInfoText("If you have made a mistake, this returns the currently selected object to its most recent position. You can step back through all movements of the current object. Once you release the object or select another, the undo list is cleared.")
	endEvent
endState

state optReset
	event OnKeyMapChangeST(int keyCode, string conflictControl, string conflictName)
	    if (conflictControl == "") || WarnKeyConflict(ConflictControl, ConflictName)
	        scrEnhGrab.kReset.SetValueInt(keyCode)
	        SetKeyMapOptionValueST(keyCode)
	    endIf	    
	endEvent

	event OnHighlightST()
		 SetInfoText("This resets the selected object to it's original Skyrim location and releases it. This is one way to fix mistakes or fix restore that have been disturbed to their pristine state. This function does not work on some static objects.")
	endEvent
endState

state optDelete
	event OnKeyMapChangeST(int keyCode, string conflictControl, string conflictName)
	    if (conflictControl == "") || WarnKeyConflict(ConflictControl, ConflictName)
	        scrEnhGrab.kDelete.SetValueInt(keyCode)
	        SetKeyMapOptionValueST(keyCode)
	    endIf	    
	endEvent

	event OnHighlightST()
		 SetInfoText("This deletes the selected object from the game. A confirmation prompt will be shown to prevent accidental deletion. This operation cannot be undone.")
	endEvent
endState

String sMovementKeysInfo = "These keys move the object in the direction selected.\nMovement is relative to the way the player is facing.\nHold keys down for continuous movement or tap keys for small increments."
String sRotationKeysInfo = "These keys rotate the object in the direction selected.\nRotation is relative to the object itself. If this is confusing, use the Level key to orient the object relative to the player.\nHold keys down for continuous rotation or tap keys for small increments."
String sScaleKeysInfo = "These keys scale the object larger or smaller.\nChanging scale may not alter the objects collision box size.\nHold keys down for continuous scaling or tap keys for small increments."

state optUp
	event OnKeyMapChangeST(int keyCode, string conflictControl, string conflictName)
	    if (conflictControl == "") || WarnKeyConflict(ConflictControl, ConflictName)
	        scrEnhGrab.kUp.SetValueInt(keyCode)
	        SetKeyMapOptionValueST(keyCode)
	    endIf	    
	endEvent

	event OnHighlightST()
		 SetInfoText("sMovementKeysInfo")
	endEvent
endState

state optDown
	event OnKeyMapChangeST(int keyCode, string conflictControl, string conflictName)
	    if (conflictControl == "") || WarnKeyConflict(ConflictControl, ConflictName)
	        scrEnhGrab.kDown.SetValueInt(keyCode)
	        SetKeyMapOptionValueST(keyCode)
	    endIf	    
	endEvent

	event OnHighlightST()
		 SetInfoText("sMovementKeysInfo")
	endEvent
endState

state optLeft
	event OnKeyMapChangeST(int keyCode, string conflictControl, string conflictName)
	    if (conflictControl == "") || WarnKeyConflict(ConflictControl, ConflictName)
	        scrEnhGrab.kLeft.SetValueInt(keyCode)
	        SetKeyMapOptionValueST(keyCode)
	    endIf	    
	endEvent

	event OnHighlightST()
		 SetInfoText("sMovementKeysInfo")
	endEvent
endState

state optRight
	event OnKeyMapChangeST(int keyCode, string conflictControl, string conflictName)
	    if (conflictControl == "") || WarnKeyConflict(ConflictControl, ConflictName)
	        scrEnhGrab.kRight.SetValueInt(keyCode)
	        SetKeyMapOptionValueST(keyCode)
	    endIf	    
	endEvent

	event OnHighlightST()
		 SetInfoText("sMovementKeysInfo")
	endEvent
endState

state optFwd
	event OnKeyMapChangeST(int keyCode, string conflictControl, string conflictName)
	    if (conflictControl == "") || WarnKeyConflict(ConflictControl, ConflictName)
	        scrEnhGrab.kFwd.SetValueInt(keyCode)
	        SetKeyMapOptionValueST(keyCode)
	    endIf	    
	endEvent

	event OnHighlightST()
		 SetInfoText("sMovementKeysInfo")
	endEvent
endState

state optBack
	event OnKeyMapChangeST(int keyCode, string conflictControl, string conflictName)
	    if (conflictControl == "") || WarnKeyConflict(ConflictControl, ConflictName)
	        scrEnhGrab.kBack.SetValueInt(keyCode)
	        SetKeyMapOptionValueST(keyCode)
	    endIf	    
	endEvent

	event OnHighlightST()
		 SetInfoText("sMovementKeysInfo")
	endEvent
endState

state optPitchUp
	event OnKeyMapChangeST(int keyCode, string conflictControl, string conflictName)
	    if (conflictControl == "") || WarnKeyConflict(ConflictControl, ConflictName)
	        scrEnhGrab.kPitchUp.SetValueInt(keyCode)
	        SetKeyMapOptionValueST(keyCode)
	    endIf	    
	endEvent

	event OnHighlightST()
		 SetInfoText("sRotationKeysInfo")
	endEvent
endState

state optLevel
	event OnKeyMapChangeST(int keyCode, string conflictControl, string conflictName)
	    if (conflictControl == "") || WarnKeyConflict(ConflictControl, ConflictName)
	        scrEnhGrab.kLevel.SetValueInt(keyCode)
	        SetKeyMapOptionValueST(keyCode)
	    endIf	    
	endEvent

	event OnHighlightST()
		 SetInfoText("Orients the object angle with respect to the player.\nThis is often a useful key to press when objects are first selected to avoid confusion over rotation orientation.")
	endEvent
endState

state optPitchDown
	event OnKeyMapChangeST(int keyCode, string conflictControl, string conflictName)
	    if (conflictControl == "") || WarnKeyConflict(ConflictControl, ConflictName)
	        scrEnhGrab.kPitchDown.SetValueInt(keyCode)
	        SetKeyMapOptionValueST(keyCode)
	    endIf	    
	endEvent

	event OnHighlightST()
		 SetInfoText("sRotationKeysInfo")
	endEvent
endState

state optYawLeft
	event OnKeyMapChangeST(int keyCode, string conflictControl, string conflictName)
	    if (conflictControl == "") || WarnKeyConflict(ConflictControl, ConflictName)
	        scrEnhGrab.kYawLeft.SetValueInt(keyCode)
	        SetKeyMapOptionValueST(keyCode)
	    endIf	    
	endEvent

	event OnHighlightST()
		 SetInfoText("sRotationKeysInfo")
	endEvent
endState

state optYawRight
	event OnKeyMapChangeST(int keyCode, string conflictControl, string conflictName)
	    if (conflictControl == "") || WarnKeyConflict(ConflictControl, ConflictName)
	        scrEnhGrab.kYawRight.SetValueInt(keyCode)
	        SetKeyMapOptionValueST(keyCode)
	    endIf	    
	endEvent

	event OnHighlightST()
		 SetInfoText("sRotationKeysInfo")
	endEvent
endState

state optRollLeft
	event OnKeyMapChangeST(int keyCode, string conflictControl, string conflictName)
	    if (conflictControl == "") || WarnKeyConflict(ConflictControl, ConflictName)
	        scrEnhGrab.kRollLeft.SetValueInt(keyCode)
	        SetKeyMapOptionValueST(keyCode)
	    endIf	    
	endEvent

	event OnHighlightST()
		 SetInfoText("sRotationKeysInfo")
	endEvent
endState

state optRollRight
	event OnKeyMapChangeST(int keyCode, string conflictControl, string conflictName)
	    if (conflictControl == "") || WarnKeyConflict(ConflictControl, ConflictName)
	        scrEnhGrab.kRollRight.SetValueInt(keyCode)
	        SetKeyMapOptionValueST(keyCode)
	    endIf	    
	endEvent

	event OnHighlightST()
		 SetInfoText("sRotationKeysInfo")
	endEvent
endState

state optScaleLarger
	event OnKeyMapChangeST(int keyCode, string conflictControl, string conflictName)
	    if (conflictControl == "") || WarnKeyConflict(ConflictControl, ConflictName)
	        scrEnhGrab.kScaleLarger.SetValueInt(keyCode)
	        SetKeyMapOptionValueST(keyCode)
	    endIf	    
	endEvent

	event OnHighlightST()
		 SetInfoText("sScaleKeysInfo")
	endEvent
endState

state optScaleSmaller
	event OnKeyMapChangeST(int keyCode, string conflictControl, string conflictName)
	    if (conflictControl == "") || WarnKeyConflict(ConflictControl, ConflictName)
	        scrEnhGrab.kScaleSmaller.SetValueInt(keyCode)
	        SetKeyMapOptionValueST(keyCode)
	    endIf	    
	endEvent

	event OnHighlightST()
		 SetInfoText("sScaleKeysInfo")
	endEvent
endState

;revert key mapping
state optResetKeyMappings
	event OnSelectST()
		;TODO: add confirm before resetting all keys
		if ShowMessage("Are you sure?", true, "Yes", "No")
			scrEnhGrab.giHotkey.SetValueInt(156)
			scrEnhGrab.kFwd.SetValueInt(200)
			scrEnhGrab.kBack.SetValueInt(208)
			scrEnhGrab.kLeft.SetValueInt(203)
			scrEnhGrab.kRight.SetValueInt(205)
			scrEnhGrab.kUp.SetValueInt(201)
			scrEnhGrab.kDown.SetValueInt(209)
			scrEnhGrab.kPitchDown.SetValueInt(72)
			scrEnhGrab.kPitchUp.SetValueInt(80)
			scrEnhGrab.kYawLeft.SetValueInt(71)
			scrEnhGrab.kYawRight.SetValueInt(73)
			scrEnhGrab.kRollLeft.SetValueInt(75)
			scrEnhGrab.kRollRight.SetValueInt(77)
			scrEnhGrab.kLevel.SetValueInt(82)
			scrEnhGrab.kDrop.SetValueInt(83)
			scrEnhGrab.kMovetoTarget.SetValueInt(78)
			scrEnhGrab.kUndo.SetValueInt(14)
			scrEnhGrab.kReset.SetValueInt(181)
			scrEnhGrab.kDelete.SetValueInt(211)
			ForcePageReset()
		EndIf
	endEvent

	event OnHighlightST()
		 SetInfoText("Click here to reset all key mappings to their default values.")
	endEvent

endState

state optLockDownCell
	event OnSelectST()
		;TODO: add confirm before resetting all keys
		if ShowMessage("Are you sure you wish to lock down every object in the current cell?", true, "$Yes", "$No")
			;close SkyUI menu
			Int kMenu = Input.GetMappedKey("Tween Menu")
			While Utility.IsInMenuMode()
				Input.TapKey(kMenu)
				Utility.WaitMenuMode(0.25)
			EndWhile

			bLockDownCell = true			
			Debug.Notification("Saving game prior to operation...")
			Game.RequestSave()
			Utility.WaitMenuMode(5.0)
			if !bLockDownCell	; save game reloaded
				Debug.Notification("Positioner has detected game reloaded. The operation to lock cell objects in place has been stopped.")
				return	;abort
			EndIf
			int iMotion_Keyframed = 4
			;int iMotion_Dynamic = 1 
			Cell kCell = Game.GetPlayer().GetParentCell()
			ObjectReference objRef
			Int iIndex = kCell.GetNumRefs(0)
	    	String sProgress = "Locking down objects, " + iIndex + " remaining"
		 	Debug.Notification(sProgress)
			while (iIndex)
			    iIndex -= 1
			    objRef = kCell.GetNthRef(iIndex, 0)
			    If objRef.GetMass()	;mass is used to identify items subject to havok settling
					;disable havok setttling
					objRef.SetMotionType(iMotion_Keyframed)
					;objRef.SetMotionType(4)
					;objRef.SetMotionType(5)
			    EndIf
			    if (iIndex % 200 == 0) && iIndex ;periodically report progress
			    	sProgress = "Locking down objects, " + iIndex + " remaining"
			    	Debug.Notification(sProgress)
			    Endif
			endwhile
	    	Debug.MessageBox("Finished locking down all objects in the current cell.")
		EndIf
	endEvent
	
	event OnHighlightST()
		 SetInfoText("This operation causes every loose item in the current cell to be locked firmly in place, preventing them from being disturbed. You will still be able to pick up objects or position them as normal.")
	endEvent
EndState

state optCheckSKSEPlugin
	event OnSelectST()
		scrEnhGrab.CheckSKSEPlugin(2)
	endEvent
	
	event OnHighlightST()
		 SetInfoText("Provides a simple way to validate that Positioner's SKSE plugin is correctly installed." + \
		 	"The plugin is required to select objects via the command console.")
	endEvent
EndState

;provides key conflict information to other mods
string function GetCustomControl(int keyCode)
;helper to notify other plugins of keymapping conflict
    if (keyCode == scrEnhGrab.giHotkey.GetValueInt())
        return "Select Object/Lock Object"
    ElseIf (keyCode == scrEnhGrab.kFwd.GetValueInt())
    	return "Move object forward"
    ElseIf (keyCode == scrEnhGrab.kBack.GetValueInt())
    	return "Move object backward"
    ElseIf (keyCode == scrEnhGrab.kLeft.GetValueInt())
    	return "Move object left"
    ElseIf (keyCode == scrEnhGrab.kRight.GetValueInt())
    	return "Move object right"
    ElseIf (keyCode == scrEnhGrab.kUp.GetValueInt())
    	return "Move object up"
    ElseIf (keyCode == scrEnhGrab.kDown.GetValueInt())
    	return "Move object down"
    ElseIf (keyCode == scrEnhGrab.kPitchDown.GetValueInt())
    	return "Rotate object pitch down"
    ElseIf (keyCode == scrEnhGrab.kPitchUp.GetValueInt())
    	return "Rotate object pitch up"
    ElseIf (keyCode == scrEnhGrab.kYawLeft.GetValueInt())
    	return "Rotate object yaw left"
    ElseIf (keyCode == scrEnhGrab.kYawRight.GetValueInt())
    	return "Rotate object yaw right"
    ElseIf (keyCode == scrEnhGrab.kRollLeft.GetValueInt())
    	return "Rotate object roll left"
    ElseIf (keyCode == scrEnhGrab.kRollRight.GetValueInt())
    	return "Rotate object roll right"
    ElseIf (keyCode == scrEnhGrab.kLevel.GetValueInt())
    	return "Level object"
    ElseIf (keyCode == scrEnhGrab.kDrop.GetValueInt())
    	return "Drop and release object"
    ElseIf (keyCode == scrEnhGrab.kMovetoTarget.GetValueInt())
    	return "Move object to target"
    ElseIf (keyCode == scrEnhGrab.kCollectStatic.GetValueInt())
    	return "Take object"
    ElseIf (keyCode == scrEnhGrab.kCopy.GetValueInt())
    	return "Copy object"
    ElseIf (keyCode == scrEnhGrab.kUndo.GetValueInt())
    	return "Undo"
    ElseIf (keyCode == scrEnhGrab.kScaleLarger.GetValueInt())
    	return "Scale object larger"
    ElseIf (keyCode == scrEnhGrab.kScaleSmaller.GetValueInt())
    	return "Scale object smaller"
    ElseIf (keyCode == scrEnhGrab.kDelete.GetValueInt())
    	return "Delete object"
    Else
        return ""
    endIf
endFunction


;help topics

state optSelectingObjects
	event OnHighlightST()
		 SetInfoText("Tap the Select key (defualt Num Enter) to begin positioning an object you have grabbed or are pointing at. Having trouble picking just the object you want? Open the command console (~) and pick the object with your mouse, then close the command console and tap the Select key.")
	endEvent
endState

state optBasics
	event OnHighlightST()
		 SetInfoText("Selected items will glow. Use arrow and keypad keys to move the item around. The Level key is useful for orienting skewed items. Once the item is where you want it, press the Select key to lock it in place or the Drop key to allow it to fall to any surface.")
	endEvent
endState

state optMount
	event OnHighlightST()
		 SetInfoText("To mount a shield or weapon on a wall, position yourself so that you are perpendicular to the wall, point at the wall where you want it and tap the Move Object to Target key. Use Level to orient it and make fine adjustments. Walk up to the item and make sure it can still be selected (not embedded irretreivably in a wall). Tap Select to lock it in place.")
	endEvent
endState

state optLockInPlace
	event OnHighlightST()
		 SetInfoText("To lock an existing item in place without moving it, you can get close and often grab it without changing the original position. Just tap Select twice and the item should be locked in place.")
	endEvent
endState

state optSetTable
	event OnHighlightST()
		 SetInfoText("Setting items on tables is easy.\nJust Select the item, Level it, point to where you want it and Move To Target. Select to lock it in place.")
	endEvent
endState

state optMoveFurniture
	event OnHighlightST()
		 SetInfoText("Positioner also allows you to move simple furniture such as chairs, beds, containers, and workstations. Point your crosshairs at the furniture until you see the activation marker (e.g., \"Sit\" for a chair) and click the Positioner select key. Move it around as you would any other item.")
	endEvent
endState

state optTakeStaticsWithYou
	event OnHighlightST()
		 SetInfoText("You can move any selected object to your inventory. Positioner creates a cube token for items that cannot normally be held in inventory, such as furniture. When you drop the token, the object will reappear in your present location. This is a great way to take home furniture and curiosities you discover in your adventures.")
	endEvent
endState

state optManipulateLights
	event OnHighlightST()
		 SetInfoText("Positioner also lets you easily manipulate lights! To do so, you need to make light objects visible and selectable by going to the Advanced Options tab and selecting that option. Each light source will then display as a small object (looks like a Chaurus egg) that you can select and manipulate just like any other.")
	endEvent
endState

state optLockDownEverything
	event OnHighlightST()
		 SetInfoText("Worried about people wrecking havok in your player home? Now you can lock everything down in one simple step. On the Advanced Operations pane, you will find an option to lock down all objects in the current cell. Once confirmed, Positioner will first save your game and then iterate through all of the items, locking each down.")
	endEvent
endState

state optCaveats
	event OnHighlightST()
		 SetInfoText("Beware that this tool will allow you to place objects beyond reach (e.g., embedded in walls). Please be careful. Quick saving before you start and as you go is a good way to undo mistakes.")
	endEvent
endState

state optSkyrimBugs
	event OnHighlightST()
		 SetInfoText("There are some known Skyrim bugs that may frustrate all your hard work. Click the mouse for details and workarounds of each known bug.")
	endEvent
	
	Event OnSelectST()
		ShowSkyrimBugWarnings()
	EndEvent
endState

Function ShowSkyrimBugWarnings()
	Debug.MessageBox("Jaxonz Positioner\nSkyrim Known Bug #1: HAVOK SETTLING" + \
		"\nItems dropped form inventory can move the next time you enter the cell.\nPlease don't let this ruin all your hard work." + \
		"\nWorkaround: Drop items from inventory, leave the cell, then open the console (~) and type pcb." + \
		" You can then return to the cell and position your item without fear that it will change location.")
	Debug.MessageBox("Jaxonz Positioner\nSkyrim Known Bug #2: HIGH FRAME RATE" + \
		"\nAt greater than 60 FPS, the Skyrim physics engine can cause items to fly around the room as if they were violently struck by something." + \
		"\nLocked-down items are safe, but loose items can be easily disturbed." + \
		"\nSolution: Turn on Vsync, edit enblocal.ini to enable FPSLimit, modify your graphics card configuration, or install an FPS Limiter Utility.")

EndFunction