﻿Scriptname JaxonzEnhGrabSimpleObject extends JaxonzEnhGrabObject  
{a mostly passthrough implementation for simple objects}

import Debug
;import JaxonzUtility
;bool bDebug = False
;bool bLock = False
ObjectReference objRef

Bool Function Instantiate (ObjectReference objBase)
	if objBase	;happy as long as objBase != none
		;force reference to base object
		Self.ForceRefTo(objBase)
		objRef = objBase
		return true
	Else
		return false
	EndIf
EndFunction

Function TranslateTo(float afX, float afY, float afZ, float afXAngle, float afYAngle, float afZAngle, float afSpeed, float afMaxRotationSpeed = 0.0)
	objRef.StopTranslation()
	objRef.TranslateTo(afX, afY, afZ, afXAngle, afYAngle, afZAngle, afSpeed, afMaxRotationSpeed)
EndFunction
  
Function StopTranslation()
	objRef.StopTranslation()
EndFunction

ObjectReference[] Function Collect()
;hides/disables the objects, returns reference to base object
	ObjectReference[] objCollection = new ObjectReference[1]
	objCollection[0] = objRef
	objRef.DisableNoWait()
	;move objects with enableparents to limbo, since they can't be disabled via script.
	If objRef.IsEnabled()
;	if objRef.GetEnableParent()
;Trace("objRef:" + objRef + " as EnableParent:" + objRef.GetEnableParent())
		;objRef.MoveTo((GetOwningQuest() as JaxonzEnhGrab).objLimboMarker)
		objRef.TranslateTo(objRef.X, objRef.Y, objRef.Z - 10000, 0,0,0,1000000)
	EndIf
	
	Clear()
	return objCollection
EndFunction

Function Restore (ObjectReference[] objCollection, ObjectReference objPlaceAtRef)
;unhides/enables objects at designated Location
	ObjectReference objBase = objCollection[0]
	objBase.Enable()
	;load into reference
	Instantiate(objBase)
	;move to the desired position
	objBase.TranslateToRef(objPlaceAtRef,100000,100000)
	;objBase.MoveTo(objPlaceAtRef)	
EndFunction

Function Release()
;releases all internal references
	objRef = none
	Self.Clear()
EndFunction

string Function GetDisplayName()
	if objRef.GetDisplayName() != ""
		return objRef.GetDisplayName()
	ElseIf objRef.GetName() != ""
		return objRef.GetName()
	ElseIf objRef.GetBaseObject().GetName() != ""
		return objRef.GetBaseObject().GetName()
	Else
		return "Static Object: " + objRef.GetBaseObject().GetFormID()
	EndIf
EndFunction

float Function GetScale()
;returns current object scale
;Debug.Notification("JaxonzEnhGrabSimpleObject GetScale:" + objRef.GetScale())
	return objRef.GetScale()
EndFunction

Function SetScale(float afScale)
;sets the object scale
	objRef.SetScale(afScale)
EndFunction