﻿Scriptname JaxonzEnhGrabWeaponPlaqueCOAObject extends JaxonzEnhGrabObject  
{specialized version for weapon-shield-weapon plaques}

;import JaxonzUtility
;Bool Property bDebug = false AutoReadOnly
Activator Property actWeaponRackCOAMidPlayerHouse Auto
Activator Property actWeaponRackCOAMid Auto

;ObjectReference objActivator
ObjectReference objPlaqueCenter
;ObjectReference objPlaqueLeft
;ObjectReference objPlaqueRight
FormList flstParts

;FormList Property flstValidForms Auto	;forms qualifying for this script

int kActivator = 24

;EffectShader shdHighlight
int iMotion_Keyframed = 4	;: The object will NOT be simulated by Havok (will only move if forced to, through SetPosition() or TranslateTo())
int kSuperFast  = 100000

Bool Function Instantiate (ObjectReference objBase)
;initialize the object for positioning
;create references to associated objects
;TraceAndNotifyConditional("JaxonzEnhGrabWeaponPlaqueCOAObject Instantiate called " + objBase, 0, bDebug)

	if !flstValidForms.HasForm(objBase.GetBaseObject())
		return false	;not one of the object types appropriate for this script
	EndIf

	Int iIterations
	ObjectReference objRef
	Cell kCell = objBase.GetParentCell()

	;all parts share the same coordinates
	
	;center part	WeaponRackCOAMidPlayerHouse
	;left plaque	WeaponRackCOALeftPlayerHouse
	;right plaque	WeaponRackCOARightPlayerHouse

	;find weapon plaque parts
	iIterations = 100
	While iIterations && !objPlaqueCenter
		objRef = Game.FindRandomReferenceOfAnyTypeInListFromRef(flstValidForms, objBase, 3.0)	;almost exact same coordinates
		if objRef && flstValidForms.HasForm(objRef.GetBaseObject())
			flstParts.AddForm(objRef)
			if (objRef.GetBaseObject() == actWeaponRackCOAMidPlayerHouse) || (objRef.GetBaseObject() == actWeaponRackCOAMid)
				objPlaqueCenter = objRef
;TraceAndNotifyConditional("objPlaqueCenter: " + objPlaqueCenter, 0, bDebug)
			EndIf
		EndIf
	EndWhile
	
	flstParts.RemoveAddedForm(objPlaqueCenter)

;TraceAndNotifyConditional("flstParts.GetSize(): " + flstParts.GetSize(), 0, bDebug)

	;double check that we have everything
	if ! (objPlaqueCenter && (flstParts.GetSize() == 5))
		Debug.Notification("Can't find all parts of weapon plaque. Unsafe to move.")
		Release()
		return false
	Else
;		objPlaque.Enable()
;		objActivator.Enable()
		;force reference to base object
		Self.ForceRefTo(objPlaqueCenter)
;		objPlaque.SetMotionType(iMotion_Keyframed)
		return true
	EndIf	
EndFunction

Function TranslateTo(float afX, float afY, float afZ, float afXAngle, float afYAngle, float afZAngle, float afSpeed, float afMaxRotationSpeed = 0.0)
;same functionality as ObjectReference.TranslateTo except that coordinates associated items
	objPlaqueCenter.TranslateTo(afX, afY, afZ, afXAngle, afYAngle, afZAngle, afSpeed, afMaxRotationSpeed)

	int iPartIndex = flstParts.GetSize()
	While iPartIndex
		iPartIndex -= 1
		(flstParts.GetAt(iPartIndex) as ObjectReference).TranslateTo(afX, afY, afZ, afXAngle, afYAngle, afZAngle, afSpeed, afMaxRotationSpeed)
	EndWhile
EndFunction
  
Function StopTranslation()
	objPlaqueCenter.StopTranslation()
	;nudge off perfect angle so that facing due north bug doesn't happen
	if ((objPlaqueCenter.GetAngleZ() as int) % 90) == 0
		objPlaqueCenter.SetAngle(0, 0, objPlaqueCenter.GetAngleZ() + 1)
	EndIf

	int iPartIndex = flstParts.GetSize()
	While iPartIndex
		iPartIndex -= 1
		(flstParts.GetAt(iPartIndex) as ObjectReference).MoveTo(objPlaqueCenter)
	EndWhile
EndFunction

Event OnTranslationComplete()
	StopTranslation()
EndEvent

ObjectReference[] Function Collect()
;hides/disables the objects, returns reference to base object
	ObjectReference[] objCollection = new ObjectReference[5]
	objCollection[0] = objPlaqueCenter
	objPlaqueCenter.Disable()

	int iPartIndex = flstParts.GetSize()
	While iPartIndex
		iPartIndex -= 1
		ObjectReference objPart = flstParts.GetAt(iPartIndex) as ObjectReference
		objCollection[iPartIndex] = objPart
		objPart.Disable()
		;move objects with enableparents to limbo, since they can't be disabled via script.
		if objPart.IsEnabled()	;.GetEnableParent()
			;objPart.MoveTo((GetOwningQuest() as JaxonzEnhGrab).objLimboMarker)
			objPart.TranslateTo(objPart.X, objPart.Y, objPart.Z - 10000, 0,0,0,1000000)
		EndIf
	EndWhile
	
	ObjectReference objTemp = objPlaqueCenter
	Release()
	
	return objCollection
EndFunction

Function Restore (ObjectReference[] objCollection, ObjectReference objPlaceAtRef)
;unhides/enables objects at designated Location
	;find the associated objects
;	Instantiate(objBase)

	;enable them
	int iPartIndex = objCollection.Length
	While iPartIndex
		objCollection[iPartIndex].Enable()
		iPartIndex -= 1
	EndWhile

	;move to this cell
;	objPlaqueCenter.MoveTo(objPlaceAtRef)
	;rotate 180 degrees to it faces the player
;	objPlaqueCenter.SetAngle(0, 0, objPlaceAtRef.GetAngleZ() + 180.0)

;	iPartIndex = flstParts.GetSize()
;	While iPartIndex
;		iPartIndex -= 1
;		(flstParts.GetAt(iPartIndex) as ObjectReference).MoveTo(objPlaqueCenter)
;	EndWhile
	TranslateTo(objPlaceAtRef.X, objPlaceAtRef.Y, objPlaceAtRef.Z, objPlaceAtRef.GetAngleX(), objPlaceAtRef.GetAngleY(), objPlaceAtRef.GetAngleZ() + 180.0, kSuperFast, 0.0)
EndFunction

Function Release()
;releases all internal references
;	shdHighlight.Stop(objMannequin)
	objPlaqueCenter = none
	flstParts.Revert()
	Self.Clear()
EndFunction

string Function GetDisplayName()
	return "Weapon Shield Plaque"
EndFunction